<template>
  <div class="container mt-5">
    <h2>Chamados</h2>

    <div v-show="showOrder">
      <div class="panel-group">
        <div class="panel panel-default">
          <div class="card-header">
            <div class="form-group row">
              <div class="col-md-9">
                <input
                  type="text"
                  class="form-control"
                  name="descricao"
                  v-model="stringBusca"
                  placeholder="Descrição"
                  required
                />
              </div>
              <div class="col-md-3">
                <a class="btn btn-warning" @click="buscar(stringBusca)">
                  <i class="fas fa-search"></i>buscar
                </a>
              </div>
              <div class="col-md-12">
                <div data-toggle="buttons" class="btn-group">
                  <label class="btn btn-sm btn-white active">
                    <input
                      type="radio"
                      v-model="searchFor"
                      value="cpf"
                      name="searchFor"
                    />
                    CPF Cliente
                  </label>
                  <label class="btn btn-sm btn-white">
                    <input
                      type="radio"
                      v-model="searchFor"
                      value="ID Chamado"
                      name="searchFor"
                    />
                    ID Chamado
                  </label>
                  <label class="btn btn-sm btn-white">
                    <input
                      type="radio"
                      v-model="searchFor"
                      value="ID Produto"
                      name="searchFor"
                    />
                    ID Produto
                  </label>

                  <div class="ml-5 mt-1 ">
                    Buscar por:
                    <h5>{{ searchFor }}</h5>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <!--------------------------------------------------------->

      <div id="accordion" v-for="chamado in chamados" v-bind:key="chamado.id">
        <div class="card" v-bind:style="{ background: color[chamado.status]}">
          <div class="card-header">
            <div class="row" >
              <a
                data-toggle="collapse"
                aria-expanded="false"
                class="dropdown-toggle mb-3"
                :href="'#n' + chamado.id"
              >
                Numero do Chamado: {{ chamado.id }}
              </a>
              <hr />
              <p>STATUS: {{ convertStatus[chamado.status] }}</p>
              <hr />
              <p>DATA DE PREVISÃO: {{ format_date(chamado.dataPrev) }}</p>
            </div>
          </div>
          <div
            v-bind:id="'n' + chamado.id"
            class="collapse list-unstyled"
            data-parent="#accordion"
          >
            <div class="card-body" style="background:white">
              ID: {{ chamado.id }}
              <hr />
              defeito relatado: {{ chamado.defRelatado }}
              <hr />
              Defeito apresentado em bancada: {{ chamado.defApresentado }}
              <hr />
              valor: {{ chamado.valor }}
              <hr />
              tecnico_id: {{ chamado.tecnico_id }}
              <hr />
              cliente_id: {{ chamado.cliente_id }}
              <hr />
              produto_id: {{ chamado.produto_id }}

              <a
                data-toggle="collapse"
                href="'#' + chamado.id"
                class="btn btn-edit btn-warning"
                @click="editar(chamado.id)"
              >
                <i class="ml-1">Encerrar</i>
              </a>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div v-show="showOrderRepair">
      <h3>Reparo</h3>
      <button class="btn btn-warning float-right" @click="turnBack()">
        voltar
      </button>

      <div class="card-body">
        Status: {{ convertStatus[chamado.status] }}
        <hr />
        ID: {{ chamado.id }}
        <hr />
        defeito relatado: {{ chamado.defRelatado }}
        <hr />
        Defeito apresentado em bancada: {{ chamado.defApresentado }}
        <hr />
        valor: {{ chamado.valor }}
        <hr />
        data de Previsão do envio do orçamento:
        {{ format_date(chamado.dataPrev) }}
        <hr />
        tecnico_id: {{ chamado.tecnico_id }}
        <hr />
        cliente_id: {{ chamado.cliente_id }}
        <hr />
        produto_id: {{ chamado.produto_id }}
        <hr />
        componentes: {{ chamado.componentsJson }}
        <hr />
        cliente_id: {{ chamado.cliente_id }}
        <hr />
        data de Entrega: {{ chamado.dataDelivery }}
        <hr />
        data de Garantia: {{ chamado.dataWaranty }}
        <hr />
        Periodo de garantia: {{ chamado.periodWaranty }}
      </div>

      <div class="card mt-5">
        <button class="btn btn-danger mx-1" @click="encerrar()">
          Detalhes
        </button>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import moment from "moment";

export default {
  data() {
    return {
      color: ['none','cyan','yellow', 'lightgreen', 'orange', 'red','red' ],

      convertStatus: ["0","Criado", "Em bancada","Orçamento Enviado", 
      "Orçamento Aprovado", "Orçamento Reprovado", "Não Aprovado, aguardando retirada",
       "Aprovado, aguardando retirada", "Aprovado, retirado", "Não Aprovado, retirado",
       "Pago, Aguardando retirada",  "desconhecido"],
      showOrder: true,
      showOrderRepair: false,
      searchFor: "",
      stringBusca: "",
      chamados: null,
      chamado: {
        id: null,
        defApresentado: null,
        defRelatado: null,
        valor: null,
        status: null,
        dataCria: null,
        dataPrev: null,
        tecnico_id: null,
        cliente_id: null,
        produto_id: null,
        dataDelivery: null,
        dataWaranty: null,
        periodWaranty: null,
        componentsJson: [],
      },
    };
  },
  watch: {
    searchFor() {
      console.log("clicked");
    },
  },
  methods: {
   
    format_date(value) {
      if (value) {
        return moment(String(value)).format("DD/MM/YYYY");
      }
    },
    verifyWaranty() {
      let dataGarantia = this.chamado.dataWaranty
      let dataEntrega = this.produto.dataDelivery

      console.log("atual", Date.parse(dataEntrega));
      console.log("garantia", Date.parse(dataGarantia));

    //   if (Date.parse(dataWaranty) >= Date.parse(dataAtual)) {
    //     this.emgarantia = " em garantia";
    //   } 
    //   else if (!this.produto.dataGarantia) {
    //     this.emgarantia = "";
    //   } 
    //   else {
    //     this.emgarantia = " fora da garantia";
    //   }
    },


    listar() {
      axios
        .get(this.$MainURL + "/chamados", {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => {
          (this.chamados = response.data), console.log(response.data);

        });
    },
    buscar(stringBusca) {
      console.log("busca", stringBusca, this.searchFor);
      if (!stringBusca) {
        this.listar();
      } else if (!this.searchFor) {
        alert("Selecione um tipo de busca");
      } else {
        if (this.searchFor == "cpf") {
          axios
            .get(this.$MainURL + "chamados/cpf/" + stringBusca)
            .then((response) => (this.chamados = response.data));
        } else if (this.searchFor == "ID Chamado") {
          axios
            .get(this.$MainURL + "chamados/order/" + parseInt(stringBusca))
            .then((response) => (this.chamados = response.data));
        } else if (this.searchFor == "ID Produto") {
          axios
            .get(this.$MainURL + "chamados/product/" + stringBusca)
            .then((response) => (this.chamados = response.data));
        }
      }
      console.log("chamados", this.chamados);
    },
    salvar() {
      if (this.chamado.id) {
        axios
          .put(this.$MainURL + "/chamados/" + this.chamado.id, this.chamado)
          // eslint-disable-next-line no-unused-vars
          .then((response) => {
            alert(`Ok, Alterado com sucesso`);
            this.listar();
            this.chamado = {};
          });
      } else {
        axios
          .post(this.$MainURL + "/chamados", this.chamado)
          .then((response) => {
            alert(`Ok, cadastrado com ID: ${response.data.id}`);
            this.listar();
            this.chamado = {};
          });
      }
    },

    turnBack() {
      this.showOrder = true;
      this.showOrderRepair = false;
    },
    editar(id) {
      // this.verifyWaranty();
      this.showOrder = false;
      this.showOrderRepair = true;
      axios
        .get(this.$MainURL + "/chamados/" + id)
        .then((response) => (this.chamado = response.data));
    },
    encerrar() {
        
        this.chamado.status = 8;
        axios
          .put(this.$MainURL + "/chamados/end/" + this.chamado.id, this.chamado)
          // eslint-disable-next-line no-unused-vars
          .then((response) => {
            alert(`Ok, Alterado com sucesso`);
            this.chamado = {};
            this.listar();
          });

    },
    excluir(id, cod) {
      if (confirm(`Confirma exclusão '${cod}`));

      axios
        .delete(this.$MainURL + "/chamados/" + id)
        // eslint-disable-next-line no-unused-vars
        .then((response) => {
          alert(`chamado '${cod}' excluido com sucesso`);
          this.listar();
        });
    },
  },
  mounted() {
    this.listar();
  },
};
</script>

<style scoped>
.btn-edit {
  position: absolute;
  top: 5rem;
  right: 5px;
  z-index: 10;
  display: block;
  padding: 0.3rem 0.4rem;
  font-size: 0.9em;
  border: 1px solid;
  border-radius: 0.25rem;
}

.form-label-group {
  position: relative;
  margin-bottom: 1rem;
}

.form-label-group > input,
.form-label-group > label {
  height: 3.125rem;
  padding: 0.75rem;
}

.form-label-group > label {
  position: absolute;
  top: 0;
  left: 0;
  display: block;
  width: 100%;
  margin-bottom: 0; /* Override default `<label>` margin */
  line-height: 1.5;
  color: #495057;
  pointer-events: none;
  cursor: text; /* Match the input under the label */
  border: 1px solid transparent;
  border-radius: 0.25rem;
  transition: all 0.1s ease-in-out;
}

.form-label-group input::-webkit-input-placeholder {
  color: transparent;
}

.form-label-group input:-ms-input-placeholder {
  color: transparent;
}

.form-label-group input::-ms-input-placeholder {
  color: transparent;
}

.form-label-group input::-moz-placeholder {
  color: transparent;
}

.form-label-group input::placeholder {
  color: transparent;
}

.form-label-group input:not(:placeholder-shown) {
  padding-top: 1.25rem;
  padding-bottom: 0.25rem;
}

.form-label-group input:not(:placeholder-shown) ~ label {
  padding-top: 0.25rem;
  padding-bottom: 0.25rem;
  font-size: 12px;
  color: #777;
}
@supports (-ms-ime-align: auto) {
  .form-label-group > label {
    display: none;
  }
  .form-label-group input::-ms-input-placeholder {
    color: #777;
  }
}

/* Fallback for IE
-------------------------------------------------- */
@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {
  .form-label-group > label {
    display: none;
  }
  .form-label-group input:-ms-input-placeholder {
    color: #777;
  }
}
</style>
